"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Frequenz definitions of power.

Copyright 2024 Frequenz Energy-as-a-Service GmbH

Licensed under the MIT License (the "License");
you may not use this file except in compliance with the License.
"""

import builtins
import frequenz.api.common.v1.types.decimal_pb2
import google.protobuf.descriptor
import google.protobuf.message
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class Power(google.protobuf.message.Message):
    """Represents a single unit of power.

    !!! note
        The power unit is denominated in MW (Megawatts), which is a unit of
        power representing the rate of energy production or consumption at any
        given moment. This differs from MWh (Megawatt-hours), which measures
        the total amount of energy delivered or consumed over a period.

    Example:
        A power plant running at 10 MW for 1 hour generates 10 MWh of energy.

    This message standardizes the representation of power in MW across all
    market applications.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MW_FIELD_NUMBER: builtins.int
    @property
    def mw(self) -> frequenz.api.common.v1.types.decimal_pb2.Decimal:
        """Power amount in Megawatts (MW)."""

    def __init__(
        self,
        *,
        mw: frequenz.api.common.v1.types.decimal_pb2.Decimal | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["mw", b"mw"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["mw", b"mw"]) -> None: ...

global___Power = Power
