"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Frequenz definitions for transformers.

Copyright:
Copyright 2023 Frequenz Energy-as-a-Service GmbH

License:
MIT
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.message
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class VoltageTransformer(google.protobuf.message.Message):
    """A representation of a voltage transformer.
    Voltage transformers are used to step up or step down the voltage, keeping
    the power somewhat constant by increasing or decreasing the current.
    If voltage is stepped up, current is stepped down, and vice versa.
    Note that voltage transformers have efficiency losses, so the output power
    is always less than the input power.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PRIMARY_FIELD_NUMBER: builtins.int
    SECONDARY_FIELD_NUMBER: builtins.int
    primary: builtins.float
    """The primary voltage of the transformer.
    This is the input voltage that is stepped up or down.
    """
    secondary: builtins.float
    """The secondary voltage of the transformer.
    This is the output voltage that is the result of stepping the primary
    voltage up or down.
    """
    def __init__(
        self,
        *,
        primary: builtins.float = ...,
        secondary: builtins.float = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing.Literal["primary", b"primary", "secondary", b"secondary"]) -> None: ...

global___VoltageTransformer = VoltageTransformer
