"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Parameters for pagination.

Copyright 2023 Frequenz Energy-as-a-Service GmbH

Licensed under the MIT License (the "License");
you may not use this file except in compliance with the License.
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.message
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class PaginationParams(google.protobuf.message.Message):
    """A message defining parameters for paginating list requests.
    It can be appended to a request message to specify the desired page of
    results and the maximum number of results per page.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    PAGE_SIZE_FIELD_NUMBER: builtins.int
    PAGE_TOKEN_FIELD_NUMBER: builtins.int
    page_size: builtins.int
    """The maximum number of results to return in a single page. The service may
    return fewer results than requested. If unspecified, the service may
    choose a reasonable default.
    May only be specified in the first request.
    """
    page_token: builtins.str
    """A token identifying a page of results to return. This should be the value
    of the `next_page_token` field in the previous response's PaginationInfo.
    For the first request, this field should be omitted.

    To avoid keeping remembering the page_size across requests, service
    implementations may choose to encode the page_size in the page_token.
    """
    def __init__(
        self,
        *,
        page_size: builtins.int = ...,
        page_token: builtins.str = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["page_size", b"page_size", "page_token", b"page_token", "params", b"params"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["page_size", b"page_size", "page_token", b"page_token", "params", b"params"]) -> None: ...
    def WhichOneof(self, oneof_group: typing.Literal["params", b"params"]) -> typing.Literal["page_size", "page_token"] | None: ...

global___PaginationParams = PaginationParams
