"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Frequenz definitions of the time increment used for electricity
deliveries and trading.

Copyright 2025 Frequenz Energy-as-a-Service GmbH

Licensed under the MIT License (the "License");
you may not use this file except in compliance with the License.
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _DeliveryDuration:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _DeliveryDurationEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_DeliveryDuration.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    DELIVERY_DURATION_UNSPECIFIED: _DeliveryDuration.ValueType  # 0
    """Default value, indicates that the duration is unspecified."""
    DELIVERY_DURATION_5: _DeliveryDuration.ValueType  # 1
    """5-minute duration"""
    DELIVERY_DURATION_15: _DeliveryDuration.ValueType  # 2
    """15-minute contract duration."""
    DELIVERY_DURATION_30: _DeliveryDuration.ValueType  # 3
    """30-minute contract duration."""
    DELIVERY_DURATION_60: _DeliveryDuration.ValueType  # 4
    """1-hour contract duration."""

class DeliveryDuration(_DeliveryDuration, metaclass=_DeliveryDurationEnumTypeWrapper):
    """DeliveryDuration represents the time increment, in minutes,
    used for electricity deliveries and trading. These durations
    serve as the basis for defining the delivery period in contracts,
    and they dictate how energy is scheduled and delivered to meet
    contractual obligations.

    !!! note "Compatibility Constraints"
        Not all delivery durations are universally
        compatible with all delivery areas or markets.
    """

DELIVERY_DURATION_UNSPECIFIED: DeliveryDuration.ValueType  # 0
"""Default value, indicates that the duration is unspecified."""
DELIVERY_DURATION_5: DeliveryDuration.ValueType  # 1
"""5-minute duration"""
DELIVERY_DURATION_15: DeliveryDuration.ValueType  # 2
"""15-minute contract duration."""
DELIVERY_DURATION_30: DeliveryDuration.ValueType  # 3
"""30-minute contract duration."""
DELIVERY_DURATION_60: DeliveryDuration.ValueType  # 4
"""1-hour contract duration."""
global___DeliveryDuration = DeliveryDuration

@typing.final
class DeliveryPeriod(google.protobuf.message.Message):
    """DeliveryPeriod represents the time period during which the contract
    is delivered. It is defined by a start timestamp and a duration.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    START_FIELD_NUMBER: builtins.int
    DURATION_FIELD_NUMBER: builtins.int
    duration: global___DeliveryDuration.ValueType
    """The length of the delivery period."""
    @property
    def start(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Start UTC timestamp represents the beginning of the delivery period.
        This timestamp is inclusive, meaning that the delivery period starts
        from this point in time.

        !!! note
            Delivery period start time constraints:
            - 5-minute durations must start at times that are multiples of
              5 minutes past the hour.
            - 15-minute durations must start at :00, :15, :30, or
              :45 past the hour.
            - 30-minute durations must start at :00 or :30 past the hour.
            - 60-minute durations must start at :00 past the hour.
        """

    def __init__(
        self,
        *,
        start: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        duration: global___DeliveryDuration.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["start", b"start"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["duration", b"duration", "start", b"start"]) -> None: ...

global___DeliveryPeriod = DeliveryPeriod
