"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Frequenz definition of entity lifetimes, based upon start and end timestamps.

Copyright 2025 Frequenz Energy-as-a-Service GmbH

Licensed under the MIT License (the "License");
you may not use this file except in compliance with the License.
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.message
import google.protobuf.timestamp_pb2
import typing

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class Lifetime(google.protobuf.message.Message):
    """Lifetime captures the timestamps indicating the active operational period of
    a microgrid asset, such as a component, connection, sensor, or any other
    entity with a limited operational lifetime.

    It is normally used to track the historical evolution of assets, and it
    determines the validity period for the asset's data.

    If the `start_timestamp` is not set, the asset is considered to be in
    operation since the beginning of the system's operational history.

    If the `end_timestamp` is not set, the asset is considered to be in
    operation indefinitely into the future.

    If the Lifetime message is completely missing, it means both timestamps are
    not set, which means the asset is considered to be in operation since the
    beginning of the system's operational history and indefinitely into the
    future.
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    START_TIMESTAMP_FIELD_NUMBER: builtins.int
    END_TIMESTAMP_FIELD_NUMBER: builtins.int
    @property
    def start_timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """The timestamp when the asset became operationally active.
        If not set, the asset is considered to be in operation since the beginning
        of the system's operational history.
        """

    @property
    def end_timestamp(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Optional timestamp when the asset's operational activity ceased.
        If not set, the asset is considered to be in operation indefinitely into
        the future.
        """

    def __init__(
        self,
        *,
        start_timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        end_timestamp: google.protobuf.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["end_timestamp", b"end_timestamp", "start_timestamp", b"start_timestamp"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["end_timestamp", b"end_timestamp", "start_timestamp", b"start_timestamp"]) -> None: ...

global___Lifetime = Lifetime
